package holeg.test_headless;


import holeg.HolegPowerFlow;
import holeg.PowerFlowSettings;
import holeg.model.Grid;
import holeg.model.GridEdge;
import holeg.model.GridNode;
import holeg.power_flow.ComplexNumber;
import holeg.simple_grid.SimpleGridBuilder;
import holeg.simple_grid.SimpleGridEdge;
import holeg.simple_grid.SimpleGridNode;

public class TestHeadlessProgram {
    public static void test() {
        // Build grid
        SimpleGridBuilder builder = new SimpleGridBuilder();
        SimpleGridNode generatorA = builder.addGenerator(new ComplexNumber(4.4));
        SimpleGridNode houseA = builder.addHouse(new ComplexNumber(1));
        SimpleGridNode houseB = builder.addHouse(new ComplexNumber(2));
        SimpleGridNode houseC = builder.addHouse(new ComplexNumber(2));
        SimpleGridNode generatorB = builder.addGenerator(new ComplexNumber(1));

        // generatorA -- houseA
        // |
        // |---- houseB -- houseC --- generatorB

        builder.connect(generatorA, houseA, 11);
        builder.connect(generatorA, houseB, 10);
        builder.connect(houseB, houseC, 10);
        builder.connect(houseC, generatorB, 10);

        // Grid
        Grid grid = builder.getGrid();
        HolegPowerFlow flow = new HolegPowerFlow();
        flow.solve(grid, PowerFlowSettings.getDefault());

        // Show results
        for (GridNode node : grid.getNodes())
            ((SimpleGridNode)node).print(System.out);
        for (GridEdge edge : grid.getEdges())
            ((SimpleGridEdge)edge).print(System.out);
    }
}
